/*
 * Copyright (C) 2010 Collabora Limited.
 *
 * Based on PopupMenuGtk.h
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef PopupMenuClutter_h
#define PopupMenuClutter_h

#include "IntRect.h"
#include "PopupMenu.h"
#include "PopupMenuClient.h"
#include <glib.h>
#include <wtf/gobject/GRefPtr.h>
#include <wtf/HashMap.h>
#include <wtf/PassRefPtr.h>
#include <wtf/RefCounted.h>

typedef struct _WebKitIPopupMenu WebKitIPopupMenu;

namespace WebCore {

class FrameView;
class Scrollbar;

class PopupMenuClutter : public PopupMenu {
public:
    PopupMenuClutter(PopupMenuClient*, WebKitIPopupMenu*);
    ~PopupMenuClutter();

    virtual void show(const IntRect&, FrameView*, int index);
    virtual void hide();
    virtual void updateFromElement();
    virtual void disconnectClient();

private:
    PopupMenuClient* client() const { return m_popupClient; }

    static void menuItemActivated(WebKitIPopupMenu*, gint, PopupMenuClutter*);
    static void menuHidden(WebKitIPopupMenu*, PopupMenuClutter*);

    PopupMenuClient* m_popupClient;
    GRefPtr<WebKitIPopupMenu> m_popup;
    bool m_initialized;
};

}

#endif // PopupMenuGtk_h
