/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2.1 of
 *  the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA
 */

#ifndef UtilClutter_h
#define UtilClutter_h

#include <clutter/clutter.h>
#include <clutter/x11/clutter-x11.h>
// Xlib defines a whole lot of names that are too generic. Bad idea.
#undef Status
#undef None
#include "IntRect.h"

namespace WebCore {

class UtilClutter  {
private:
    UtilClutter() { };
    ~UtilClutter() { };

public:
    static bool stageX11GetRootCoords(ClutterStage *stage, IntPoint position, IntPoint &root);
    static void convertEventCoords(ClutterActor* actor, float x, float y, IntPoint& actorPosition, IntPoint &globalPosition);
    static void applyInverseChildTransform(ClutterActor* actor, float x, float y, IntPoint& actorPosition);
};

}

#endif
