/*
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "Color.h"

#include "webkitclutterinclude.h"

namespace WebCore {

Color::Color(const ClutterColor& c)
    : m_color(makeRGBA(static_cast<int>(c.red), static_cast<int>(c.green), static_cast<int>(c.blue), abs(255 - static_cast<int>(c.alpha))))
    , m_valid(true)
{
}
Color::operator ClutterColor() const
{
    ClutterColor c = { static_cast<guint8>(red()), static_cast<guint8>(green()), static_cast<guint8>(blue()),
                       static_cast<guint8>(abs(255 - static_cast<int>(alpha()))) };
    return c;
}

}

// vim: ts=4 sw=4 et
