/*
 * ClutterSocket: An XEmbed server for Clutter.
 *
 * Copyrigth (C) 2010 Collabora Ltd
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CLUTTER_SOCKET_H__
#define __CLUTTER_SOCKET_H__

#include <clutter/clutter.h>
#include <clutter/x11/clutter-x11.h>

G_BEGIN_DECLS

#define CLUTTER_TYPE_SOCKET                  (clutter_socket_get_type())
#define CLUTTER_SOCKET(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLUTTER_TYPE_SOCKET, ClutterSocket))
#define CLUTTER_SOCKET_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass), CLUTTER_TYPE_SOCKET, ClutterSocketClass))
#define CLUTTER_IS_SOCKET(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLUTTER_TYPE_SOCKET))
#define CLUTTER_IS_SOCKET_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass), CLUTTER_TYPE_SOCKET))
#define CLUTTER_SOCKET_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), CLUTTER_TYPE_SOCKET, ClutterSocketClass))

typedef struct _ClutterSocket        ClutterSocket;
typedef struct _ClutterSocketClass   ClutterSocketClass;
typedef struct _ClutterSocketPrivate ClutterSocketPrivate;

struct _ClutterSocket
{
  ClutterActor           parent;

  ClutterSocketPrivate *priv;
};

struct _ClutterSocketClass
{
  ClutterActorClass parent_class;

  void     (*plug_added)   (ClutterSocket *socket);
  gboolean (*plug_removed) (ClutterSocket *socket);

  /* padding for future expansion */
  void (*_clutter_socket_reserved1) (void);
  void (*_clutter_socket_reserved2) (void);
  void (*_clutter_socket_reserved3) (void);
  void (*_clutter_socket_reserved4) (void);
};

GType clutter_socket_get_type (void) G_GNUC_CONST;

ClutterActor *clutter_socket_new            (void);
ClutterActor *clutter_socket_new_for_window (Window xid);
Window        clutter_socket_get_own_window (ClutterSocket *socket);

G_END_DECLS

#endif /* __CLUTTER_SOCKET_H__ */
