/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _MX_RENDER_THEME_H
#define _MX_RENDER_THEME_H

#include <webkit/webkitirendertheme.h>

G_BEGIN_DECLS

#define MX_TYPE_RENDER_THEME            (mx_render_theme_get_type())
#define MX_RENDER_THEME(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), MX_TYPE_RENDER_THEME, MxRenderTheme))
#define MX_RENDER_THEME_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  MX_TYPE_RENDER_THEME, MxRenderThemeClass))
#define MX_IS_RENDER_THEME(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), MX_TYPE_RENDER_THEME))
#define MX_IS_RENDER_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  MX_TYPE_RENDER_THEME))
#define MX_RENDER_THEME_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  MX_TYPE_RENDER_THEME, MxRenderThemeClass))

typedef struct _MxRenderTheme MxRenderTheme;
typedef struct _MxRenderThemeClass MxRenderThemeClass;

struct _MxRenderTheme {
    GObject parent_instance;
};

struct _MxRenderThemeClass {
    GObjectClass parent_class;

    /* Padding for future expansion */
    void (*_webkit_reserved0) (void);
    void (*_webkit_reserved1) (void);
    void (*_webkit_reserved2) (void);
    void (*_webkit_reserved3) (void);
};

WEBKIT_API GType
mx_render_theme_get_type                        (void);

WEBKIT_API MxRenderTheme*
mx_render_theme_new                             (void);

G_END_DECLS

#endif
