/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA
 */

#include "config.h"
#include "webkitglobals.h"

#include <cairo.h>
#include <clutter/clutter.h>
#include <mx/mx.h>
#include <webkit/webkitirendertheme.h>
#include <webkit/webkitdefines.h>
#include "mx-render-theme.h"

extern void webkitInit();

WEBKIT_API void webkit_init ();

void webkit_init()
{
    static gboolean isInitialized = FALSE;
    if (isInitialized)
        return;
    isInitialized = TRUE;

    webkitInit();

    webkit_irender_theme_set_default(WEBKIT_IRENDER_THEME(mx_render_theme_new()));
}
