/*
 * Copyright 2010 Collabora Limited
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU Lesser General Public License,
 * version 2.1, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef _WEBKIT_MX_POPUP_MENU_H
#define _WEBKIT_MX_POPUP_MENU_H

#include <mx/mx.h>
#include <webkit/webkitdefines.h>

G_BEGIN_DECLS

#define WEBKIT_MX_TYPE_POPUP_MENU webkit_mx_popup_menu_get_type()

#define WEBKIT_MX_POPUP_MENU(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST ((obj), \
          WEBKIT_MX_TYPE_POPUP_MENU, WebKitMxPopupMenu))

#define WEBKIT_MX_POPUP_MENU_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST ((klass), \
          WEBKIT_MX_TYPE_POPUP_MENU, WebKitMxPopupMenuClass))

#define WEBKIT_MX_IS_POPUP_MENU(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), \
          WEBKIT_MX_TYPE_POPUP_MENU))

#define WEBKIT_MX_IS_POPUP_MENU_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE ((klass), \
          WEBKIT_MX_TYPE_POPUP_MENU))

#define WEBKIT_MX_POPUP_MENU_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS ((obj), \
          WEBKIT_MX_TYPE_POPUP_MENU, WebKitMxPopupMenuClass))

typedef struct _WebKitMxPopupMenu WebKitMxPopupMenu;
typedef struct _WebKitMxPopupMenuClass WebKitMxPopupMenuClass;
typedef struct _WebKitMxPopupMenuPrivate WebKitMxPopupMenuPrivate;

/**
 * WebKitMxPopupMenu:
 *
 * The contents of this structure are private and should only be accessed
 * through the public API.
 */
struct _WebKitMxPopupMenu
{
  MxDialog parent;

  WebKitMxPopupMenuPrivate *priv;
};

struct _WebKitMxPopupMenuClass
{
  MxDialogClass parent_class;

  /* padding for future expansion */
  void (*_padding_0) (void);
  void (*_padding_1) (void);
  void (*_padding_2) (void);
  void (*_padding_3) (void);
  void (*_padding_4) (void);
};

WEBKIT_API GType
webkit_mx_popup_menu_get_type (void) G_GNUC_CONST;

WEBKIT_API WebKitMxPopupMenu*
webkit_mx_popup_menu_new (void);

G_END_DECLS

#endif /* _WEBKIT_MX_POPUP_MENU_H */
