/*
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef webkitdefaultrendertheme_h
#define webkitdefaultrendertheme_h

#include <webkit/webkitdefines.h>
#include <webkit/webkitenumtypes.h>
#include <webkit/webkitirendertheme.h>

G_BEGIN_DECLS

#define WEBKIT_TYPE_DEFAULT_RENDER_THEME            (webkit_default_render_theme_get_type())
#define WEBKIT_DEFAULT_RENDER_THEME(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_TYPE_DEFAULT_RENDER_THEME, WebKitDefaultRenderTheme))
#define WEBKIT_DEFAULT_RENDER_THEME_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_TYPE_DEFAULT_RENDER_THEME, WebKitDefaultRenderThemeClass))
#define WEBKIT_IS_DEFAULT_RENDER_THEME(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_TYPE_DEFAULT_RENDER_THEME))
#define WEBKIT_IS_DEFAULT_RENDER_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_TYPE_DEFAULT_RENDER_THEME))
#define WEBKIT_DEFAULT_RENDER_THEME_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_TYPE_DEFAULT_RENDER_THEME, WebKitDefaultRenderThemeClass))

typedef struct _WebKitDefaultRenderTheme WebKitDefaultRenderTheme;
typedef struct _WebKitDefaultRenderThemeClass WebKitDefaultRenderThemeClass;

struct _WebKitDefaultRenderTheme {
    GObject parent_instance;
};

struct _WebKitDefaultRenderThemeClass {
    GObjectClass parent_class;

    /* Padding for future expansion */
    void (*_webkit_reserved0) (void);
    void (*_webkit_reserved1) (void);
    void (*_webkit_reserved2) (void);
    void (*_webkit_reserved3) (void);
};

WEBKIT_API GType
webkit_default_render_theme_get_type                        (void);

WEBKIT_API WebKitDefaultRenderTheme*
webkit_default_render_theme_new                             (void);

G_END_DECLS

#endif
