/*
 * Copyright (C) 2011 Collabora Ltd.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include "config.h"
#include "DragClientGObject.h"
#include "NotImplemented.h"

using namespace WebCore;

namespace WebKit {

DragClientGObject::~DragClientGObject()
{
}

void DragClientGObject::willPerformDragDestinationAction(DragDestinationAction, DragData*)
{
}

void DragClientGObject::willPerformDragSourceAction(DragSourceAction action, const IntPoint& startPos, Clipboard*)
{
}

DragDestinationAction DragClientGObject::actionMaskForDrag(DragData*)
{
    notImplemented();
    return DragDestinationActionAny;
}

DragSourceAction DragClientGObject::dragSourceActionMaskForPoint(const IntPoint&)
{
    notImplemented();
    return DragSourceActionAny;
}

DragImageRef DragClientGObject::createDragImageForLink(KURL&, const String& label, Frame*)
{
    return 0;
}

void DragClientGObject::dragControllerDestroyed()
{
    delete this;
}

}
