#include "config.h"
#include "DumpRenderTreeSupportGObject.h"

#include "webkitgwebframe.h"
#include "webkitmarshal.h"

enum {
    DID_RECEIVE_RESPONSE,
    FRAME_LOAD_STATUS_CHANGED,
    DID_CHANGE_ICONS,
    LAST_SIGNAL
};

static guint drt_support_gobject_signals[LAST_SIGNAL] = { 0, };

G_DEFINE_TYPE(DRTSupportGObject, drt_support_gobject, G_TYPE_OBJECT)

static void drt_support_gobject_class_init(DRTSupportGObjectClass* drtSupportClass)
{
    /**
     * DRTSupportGObject::did-receive-response:
     */
    drt_support_gobject_signals[DID_RECEIVE_RESPONSE] = g_signal_new("did-receive-response",
            G_TYPE_FROM_CLASS(drtSupportClass),
            (GSignalFlags)G_SIGNAL_RUN_LAST,
            0,
            NULL,
            NULL,
            webkit_marshal_VOID__STRING_STRING,
            G_TYPE_NONE, 2,
            G_TYPE_STRING,
            G_TYPE_STRING);

    /**
     * DRTSupportGObject::frame-load-status-changed:
     */
    drt_support_gobject_signals[FRAME_LOAD_STATUS_CHANGED] = g_signal_new("frame-load-status-changed",
            G_TYPE_FROM_CLASS(drtSupportClass),
            (GSignalFlags)G_SIGNAL_RUN_LAST,
            0,
            NULL,
            NULL,
            g_cclosure_marshal_VOID__OBJECT,
            G_TYPE_NONE, 1,
            WEBKIT_TYPE_WEB_FRAME);

    /**
     * DRTSupportGObject::did-change-icons:
     */
    drt_support_gobject_signals[DID_CHANGE_ICONS] = g_signal_new("did-change-icons",
            G_TYPE_FROM_CLASS(drtSupportClass),
            (GSignalFlags)G_SIGNAL_RUN_LAST,
            0,
            NULL,
            NULL,
            g_cclosure_marshal_VOID__OBJECT,
            G_TYPE_NONE, 1,
            WEBKIT_TYPE_WEB_FRAME);
}

static void drt_support_gobject_init(DRTSupportGObject* webPage)
{
}

DRTSupportGObject* drt_support_gobject_new()
{
    return DRT_SUPPORT_GOBJECT(g_object_new(DRT_SUPPORT_TYPE_GOBJECT, 0));
}
